#include "consume_data.h"

Consume_data::Consume_data()
{

}

//************************************
//struct Temp_storage{						// This struct is pretty generic. Each thread stores its intermediate
//	float **xt;								// results here. In the End all threads combine their partial result into one.
//	float **xs;								// It is more efficient than competing for mutexes all the time.
//	int nt;
//	int ns;									// xt,xs,nt,ns are as in PDT-paper.
// ###
//	struct Freq{
//	int *numall;							// # of alleles for ith locus
//	float **afreq;							// freq. of marker alleles, sum == 1

Consume_data::~Consume_data()
{
	int i;
	for(i = 0; i < size; i++){
		delete [] storage.xst[i];
		delete [] storage.yst[i];
		delete [] storage.used[i];
		delete [] storage.d[i];
		delete [] storage.dsq[i];
	}
	if(mrkgeno != NULL){
		for(i = 0; i < max_ped_size; i++){
			delete mrkgeno[i];
		}
		delete [] mrkgeno;
	}
	delete [] storage.xst;
	delete [] storage.yst;
	delete [] storage.used;
	delete [] storage.d;
	delete [] storage.dsq;
	delete [] storage.fams;
	delete [] storage.useage;
	delete [] storage.ntf;
	delete [] storage.nsf;
	if(check){
		delete [] storage.ns;
		delete [] storage.nt;
	}
	else{
		delete storage.ns;
		delete storage.nt;
	}
	for(i = 0; i < 2; i++){
		delete [] indiv1[i];
		delete [] indiv2[i];
		delete [] indiv3[i];
	}
	delete [] indiv1;
	delete [] indiv2;
	delete [] indiv3;
	if(genopdt == 1){
		delete [] genostore;
	}
	if(verbose && (1 == window)){
		for(i = 0; i < size; i++){
			delete [] storage.sibs_aff[i];
			delete [] storage.sibs_una[i];
			delete [] storage.triads_nottr[i];
			delete [] storage.triads_trans[i];
			delete [] storage.homo_par[i];
		}
		delete [] storage.sibs_aff;
		delete [] storage.sibs_una;
		delete [] storage.triads_nottr;
		delete [] storage.triads_trans;
		delete [] storage.homo_par;
	}
	if(Consume_data::fptrped != NULL){
		fclose(fptrped);
	}
}

//************************************

void Consume_data::init(int s, int idnum, struct Freq *fr, struct Freq *h, int ch, int w, int opt, int gp, int mp, int ver, int store, int pdtstat)
{
	int i;
	int temp;
	Consume_data::fr = fr;
	Consume_data::hfr = h;
	Consume_data::size = s;
	Consume_data::verbose = ver;
	Consume_data::window = w;
	Consume_data::check = ch;
	Consume_data::store_d = store;
	Consume_data::genopdt = gp;
	Consume_data::ana_opt = opt;
	Consume_data::max_ped_size = mp;
	Consume_data::pdtave = pdtstat;
//	fprintf(stderr,"consumer::init:Before 1. size = %i, window = %i, temp1 = %i tempn = %i\n",size,window,hfr->numall[0],hfr->numall[size-window]);
	if(w > s){
		fprintf(stderr,"Consume_data::init. Sliding window exceeds number of loci. Bailing out\n");
		exit(0);
	}
	temp = size - window + 1;
	Consume_data::sib_list = new unsigned char[max_ped_size];
	Consume_data::storage.ns = new int[temp];
	Consume_data::storage.nt = new int[temp];	
	Consume_data::storage.nsf = new int[temp];
	Consume_data::storage.ntf = new int[temp];	

	Consume_data::storage.fams = new int[temp];
	Consume_data::storage.useage = new int[temp];
	memset((void*)storage.fams, 0, temp * sizeof(int));
	memset((void*)storage.useage, 0, temp * sizeof(int));
	memset((void*)storage.ns, 0, temp * sizeof(int));
	memset((void*)storage.nt, 0, temp * sizeof(int));
	Consume_data::storage.xst = NULL;
	Consume_data::storage.d = NULL;
	Consume_data::storage.dsq = NULL;
	Consume_data::storage.used = NULL;
	Consume_data::storage.yst = NULL;
	Consume_data::storage.sibs_aff = NULL;
	Consume_data::storage.sibs_una = NULL;
	Consume_data::storage.triads_nottr = NULL;
	Consume_data::storage.triads_trans = NULL;
	Consume_data::storage.xst = new int*[size - window + 1];
	Consume_data::storage.yst = new int*[size - window + 1];
	Consume_data::storage.used = new int*[size - window + 1];
	Consume_data::storage.d = new float*[size - window + 1];
	Consume_data::storage.dsq = new float*[size - window + 1];
	if(verbose && (1 == window)){
		Consume_data::storage.sibs_aff = new int*[size];
		Consume_data::storage.sibs_una = new int*[size];
		Consume_data::storage.triads_nottr = new int*[size];
		Consume_data::storage.triads_trans = new int*[size];
		Consume_data::storage.homo_par = new int*[size];
		for(i = 0; i < size; i++){
			temp = fr->numall[i];
			storage.sibs_aff[i] = new int[temp];
			storage.sibs_una[i] = new int[temp];
			storage.triads_nottr[i] = new int[temp];
			storage.triads_trans[i] = new int[temp];
			storage.homo_par[i] = new int[temp];
			memset((void*)storage.sibs_aff[i], 0, temp * sizeof(int));
			memset((void*)storage.sibs_una[i], 0, temp * sizeof(int));
			memset((void*)storage.triads_nottr[i], 0, temp * sizeof(int));
			memset((void*)storage.triads_trans[i], 0, temp * sizeof(int));
			memset((void*)storage.homo_par[i], 0, temp * sizeof(int));
		}
	}
	if(Consume_data::ana_opt == 4){
		Consume_data::fptrped = fopen("pdtreport.ped", "w");			// open file for writing
		Consume_data::mrkgeno = new unsigned char*[max_ped_size];
		for(i = 0; i < max_ped_size; i++){
			mrkgeno[i] = new unsigned char[2*size];						// 2 per marker/1 per allele
			if(mrkgeno[i] == NULL){
				fprintf(stderr,"Consume_data::init. Error allocating memory for mrkgeno**. Bailing out\n");
				exit(0);
			}
		}
	}
	else{
		Consume_data::fptrped = NULL;
		Consume_data::mrkgeno = NULL;
	}
	if(genopdt == 1){
		genostore = new int[max_geno];
	}
	else{
		genostore = NULL;
	}
	if((storage.xst == NULL) || (storage.d == NULL) || (storage.dsq == NULL) || (storage.yst == NULL)){
		fprintf(stderr,"Consume_data::init()/1. memory allocation error. Bailing out\n");
		exit(0);
	}
	for(i = 0; i < (size - window + 1); i++){
		storage.xst[i] = NULL;
		storage.d[i] = NULL;
		storage.dsq[i] = NULL;
		if(genopdt == 0){
			temp = fr->numall[i];
		}
		else{												// geno-PDT
			temp = (fr->numall[i] * (fr->numall[i] + 1)) / 2;
		}

		storage.xst[i] = new int[temp];
		storage.yst[i] = new int[temp];
		storage.used[i] = new int[temp];
		storage.d[i] = new float[temp];
		storage.dsq[i] = new float[temp];
		if((storage.xst[i] == NULL) || (storage.xst[i] == NULL) || (storage.d[i] == NULL) || (storage.dsq[i] == NULL)){
			fprintf(stderr,"Consume_data::init()/2. memory allocation error. Bailing out\n");
			exit(0);
		}
		memset((void*)storage.xst[i], 0, temp * sizeof(int));
		memset((void*)storage.yst[i], 0, temp * sizeof(int));
		memset((void*)storage.used[i], 0, temp * sizeof(int));
		memset((void*)storage.d[i], 0, temp * sizeof(float));
		memset((void*)storage.dsq[i], 0, temp * sizeof(float));
	}
//fprintf(stderr,"consumer::init:Before 3,size = %i, window = %i, temp1 = %i tempn = %i\n",size,window,hfr->numall[0],hfr->numall[size-window]);
	Consume_data::fam_count = 0;
	Consume_data::id = idnum;
	indiv1 = new unsigned char*[2];
	indiv2 = new unsigned char*[2];
	indiv3 = new unsigned char*[2];
	if((indiv1 == NULL) || (indiv2 == NULL) || (indiv3 == NULL)){
		fprintf(stderr,"Consume_data::init()/3. memory allocation error. Bailing out\n");
		exit(0);
	}
	for(i = 0; i < 2; i++){
		indiv1[i] = new unsigned char[s];
		if(indiv1[i] == NULL){
			fprintf(stderr,"Consume_data::init()/4. memory allocation error. Bailing out\n");
			exit(0);
		}
	}
	for(i = 0; i < 2; i++){
		indiv2[i] = new unsigned char[s];
		if(indiv2[i] == NULL){
			fprintf(stderr,"Consume_data::init()/5. memory allocation error. Bailing out\n");
			exit(0);
		}
	}	for(i = 0; i < 2; i++){
		indiv3[i] = new unsigned char[s];
		if(indiv3[i] == NULL){
			fprintf(stderr,"Consume_data::init()/6. memory allocation error. Bailing out\n");
			exit(0);
		}
	}
}

//************************************

void Consume_data::run()
// the synchronization structure below
//struct Read_sync{							// structure that tells use where the data is, what is used, what is ready and what is empty
//	int done;								// initialized to 0, when EOF is encountered the reader sets it to 1 and returns a "not genotyped" Fam upon call to next().
//											// Consumers decremts "thread_count" and exits. Upon a "thread_count" of 0 the reader exits as well.
//	int thread_count;						// Number of active consumer threads. Return when this number reaches 0.
//	int size;								// how many items (i.e. struct Fam) are in list
//	int free;								// how many items are ready to be filled by producer (i.e. reader)
//	int ready;								// how many items are filled by producer, waiting to be consumed
//	int *list;								// status of each "struct Fam".		-1 = free, ready to recieve data
//											//									0  = ready, filled with data, waiting to be consumed
//											//									1  = currently being used by consumer or producer
//	pthread_mutex_t mut_reader;				// lock if "Read_sync" is updated, that's between ONE reader and 1+ consumer(s)
//	pthread_cond_t cond_waiting_producer;	// if reader is waiting on consumers
//	pthread_cond_t cond_waiting_consumer;	// if consumer is waiting on producer/reader
//};
//*** struct Result ***
//struct Result{
//	int pedigrees;							// init to 0, increment by one for each pedigree processed
//	int size;								// number of loci & of pointer below
//	float *data;							// init this to all zeros. Each consumer gets to update this with their own data (also of type "struct Result"
//	pthread_mutex_t mut_consumer;			// lock if "Global_data" is updated, that's only between competing consumers
//};
{
	int i,j;
	int temp;
	pthread_mutex_lock(&read_synchronizer->mut_reader);						// lock the reader-sync mutex
	while((read_synchronizer->done == 0) || (read_synchronizer->ready > 0)){
//		fprintf(stderr,"consumer::run %i top , done = %i, ready = %i, free = %i\n",id,read_synchronizer->done,read_synchronizer->ready, read_synchronizer->free);
		while((read_synchronizer->ready == 0) && (read_synchronizer->done == 0)){
			pthread_cond_wait(&read_synchronizer->cond_waiting_consumer,&read_synchronizer->mut_reader);
		}
//		fprintf(stderr,"consumer %i wake, done = %i, ready = %i, free = %i\n",id,read_synchronizer->done,read_synchronizer->ready, read_synchronizer->free);
		if((read_synchronizer->done == 1) && (read_synchronizer->ready == 0)){								// some other thread finished the job, let's get out of here and have a beer!
			pthread_mutex_unlock(&result->mut_consumer);
			break;
		}
		i = 0;
		while((i < read_synchronizer->size) && (read_synchronizer->list[i] != 0)){
			i++;
		}
		if(i == read_synchronizer->size){
			fprintf(stderr,"Consume_data::run(): no ready Fam, error in  read_synchronizer. Bailing out.\n");
			exit(0);
		}
		read_synchronizer->list[i] = 1;								// this indicates we are using the ith slot
		read_synchronizer->ready--;									// this one is ours!!!
		pedid = read_synchronizer->ped_id;							// that's the place where we will store data for this pedigree 
		read_synchronizer->ped_id++;
		pthread_mutex_unlock(&read_synchronizer->mut_reader);		// release the lock, since we updated the sync. structure
		// we found us a candiadate to process, let's get on with it. It is properly marked as "read_synchronizer->list[i] = 1", so nobody else will mess with it
//		fprintf(stderr,"consumer %i before calculate\n",id);

		if(Consume_data::check || (Consume_data::window > 1)){
			if(Consume_data::ana_opt == 4){
				check_ped(families[i]);								// putx in "x" for impossible genotypes (nuc. families)
			}
			else{
				calculate_c(families[i]);								// check data
			}
		}
		else{
			fprintf(stderr,"Consume_data::run(). Unkown option, window = %i\n", window);
			exit(0);
		}
		fam_count++;												// increment for each family procesed
//		fprintf(stderr,"family = %i, ID = %i\n", fam_count, families[i].id);
		pthread_mutex_lock(&read_synchronizer->mut_reader);
		temp = read_synchronizer->free;
		read_synchronizer->list[i] = -1;
		read_synchronizer->free++;
		if(temp == 0){												// in this case wake up producer.
			pthread_cond_broadcast(&read_synchronizer->cond_waiting_producer);
		}
//		fprintf(stderr,"consumer %i bottom of loop, famcount = %i\n",id,fam_count);
	}
//	fprintf(stderr,"consumer %i at end of while loop\n",id);
	pthread_mutex_unlock(&read_synchronizer->mut_reader);					// in either case we must release the mutex
	pthread_mutex_lock(&result->mut_consumer);
	result->pedigrees += fam_count;
	int s;
//	if(!check){
//		*(result->ns) += *(storage.ns);
//		*(result->nt) += *(storage.nt);
//	}

	int max = size - window + 1;
	for(i = 0; i < max; i++){
		if(genopdt == 0){
			s = hfr->numall[i];											// number of alleles
		}
		else{
			s = (hfr->numall[i] * (hfr->numall[i] + 1)) / 2;			// number of geno-types
		}
		for(j = 0; j < s; j++){
			result->data1[i][j] += storage.d[i][j];
			result->data2[i][j] += storage.dsq[i][j];
			result->data3[i][j] += storage.used[i][j]; 
		}
		if(verbose){
			for(j = 0; j < s; j++){
				result->data4[i][j] += storage.sibs_aff[i][j];
				result->data5[i][j] += storage.sibs_una[i][j];
				result->data6[i][j] += storage.triads_trans[i][j];
				result->data7[i][j] += storage.triads_nottr[i][j];
				result->data8[i][j] += storage.homo_par[i][j];
			}
		}
		result->ns[i] += storage.ns[i];
		result->nt[i] += storage.nt[i];
		result->fams[i] += storage.fams[i];
	}

	pthread_mutex_unlock(&result->mut_consumer);
	pthread_cond_broadcast(&read_synchronizer->cond_waiting_consumer);
}

//************************************

int Consume_data::check_if_typed_nucfam(struct Fam& fa, int parents[])
{
	int i;
	int isnuc = 0;
	parents[0] = -1;
	parents[1] = -1;
	int parentsfound = 0;
	int offspringsfound = 0;
	int temp1;
	int temp2;
	for(i = 0; i < fa.members; i++){
		temp1 = fa.geno[i][2];
		temp2 = fa.geno[i][3];
		if((temp1 == 0) && (temp2 == 0) && (fa.geno[i][6] != 0)){
			if(parentsfound < 2){
				parents[parentsfound] = i;
			}
			parentsfound++;
		}
	}
	if(parentsfound == 2){
		for(i = 0; i < fa.members; i++){
			temp1 = fa.geno[i][2];
			temp2 = fa.geno[i][3];
			if((((temp1 == parents[0]) && (temp2 == parents[1])) || ((temp1 == parents[1]) && (temp2 == parents[0]))) && (fa.geno[i][6] != 0)){
				offspringsfound++;
			}
		}
		temp1 = offspringsfound + 2;								// +2 parents
		if((temp1 == fa.members) && (temp1 > 2)){					// now we know we are dealing with a complete TYPED nuclear family with 1+ offspring
			isnuc = 1;
		}
	}
	return(isnuc);
}

//************************************

void Consume_data::haplotize(unsigned char *intype, unsigned char **outtype)
// intype: fa.geno[i], somebodies read-in genotype data
// outtype: [0][size-window+1] are the "left" haplotypes and [1][size-window+1] are the "right" haplotypes
{
	unsigned char left;
	unsigned char right;
	unsigned char hapl;
	unsigned char hapr;
	int i,j,k;
	int offset;
	int index;
	int stop;
	int done;
	int multiplier;
	unsigned char *lefthap = new unsigned char[window];
	unsigned char *righthap = new unsigned char[window];
	int *trueindex = new int[window];
//for(k=0; k < 6;k++){
//printf("%3i ",intype[k]);
//}
	j = window - 1;
	for(i = 0; i < j; i++){										// this obviously won't execute if window == 1
		offset = 6+i;											// It gets the very first window. After that we keep on sliding down, one at a time
		left = intype[offset] & 0xf0;
		left >>= 4; 
		right = intype[offset] & 0x0f;
		lefthap[i] = left;
		righthap[i] = right;
		trueindex[i] = fr->numall[i];							// we need to record the number of alleles at that locus
	}
	for(i = window - 1, j = 0; i < size; i++,j++){				// j counts the advancing window, i the marker that was read-in
		offset = 6+i;
		left = intype[offset] & 0xf0;
		left >>= 4;
		right = intype[offset] & 0x0f;
		index = i % window;
		lefthap[index] = left;
		righthap[index] = right;
		trueindex[index] = fr->numall[i];						// remember the number of alleles
		hapl = 0;												// reset left & right haplotype
		hapr = 0;
		multiplier = 1;											// reset the multiplier to 1, then multiply by number of alleles @ previous locus
// EXAMPLE: Assume you have window == 3 (i.e. 3-loci haplotypes), the number of alleles are: 2,4,3 respectively
// haplo = number assigned to haplo(alleles start at 0 instead of the usual 1...otherwise this scheme does not work)
// 0-0-0 = 0
// 0-0-1 = 1
// 0-0-2 = 2
// 0-1-0 = 3
// ...
// 1-3-2 = 23
// we have 24 distinct haplotypes. Which ID number do we assign to 1-3-0 for example?
// 0 * (1) + 3 * (3) + 1 * (12) = 21 so the digits are valued "1", "3", "3*4=12"
		k = (i+1) % window;
		stop = index;
		done = 0;
		while(done == 0){
//		for(k = 0; k < window; k++){
			hapl += ((lefthap[k]-1) * multiplier);
			hapr += ((righthap[k]-1) * multiplier);
//printf(" %i  %i,",lefthap[k],righthap[k]);
			multiplier *= trueindex[k];
			if((lefthap[k] == 0) || (righthap[k] == 0)){		// some locus not typed => haplotype not typed 
				hapl = 255;										// we can't use "0" since it is a valid haplotype, so use "-1"
				hapr = 255;
				break;
			}
			if(k == stop){
				done = 1;
			}
			k++;
			k %= window;
		}
		outtype[0][j] = hapl;
		outtype[1][j] = hapr;
//printf("%4i %4i #",hapl,hapr);
	}
	delete [] trueindex;
	delete [] lefthap;
	delete [] righthap;

//printf("\n");
}

//************************************

void Consume_data::explode_geno(struct Fam& fa)
{
	int i,j;
	int offset;											// index in compressed fa.geno[indivID][index]
	int index;											// index into mrkgeno[indivID][index]
	unsigned char left;

	for(i = 0; i < fa.members; i++){					// i == indivID
		index = 0;
		for(j = 0; j < size; j++){
			offset = 6+j;
			left = fa.geno[i][offset] & 0xf0;
			left >>= 4;
			mrkgeno[i][index++] = left;
			mrkgeno[i][index++] = fa.geno[i][offset] & 0x0f;
		}
	}
}

//************************************

void Consume_data::check_ped(struct Fam& fa)
{
	/*
struct Fam{								// structure that holds the data
	int id;								// family identifier
	int members;						// each Family has 2 parents and "members - 2" children
	int loci;							// number of loci, kind of redundant since all Fams are going to have the same number
	unsigned char **geno;				// geno[i][j] is for the ith member and jth locus
										// geno[i][0] holds 0|1. 0 = not genotyped, 1 = valid data
										// geno[members][loci+6]
										// geno[i][1] = "individual ID"
										// geno[i][2] = "1st parent"
										// geno[i][3] = "2nd parent"
										// geno[i][4] = "male=1,female=2"
										// geno[i][5] = "aff.stat. aff=1,unaff=2,unkown=0"
										// geno[i][6+] = "upper 4 bits allele1, lower 4 bits allele2"

};
	*/
// Startegy: We examine one nuclear family at a time. If the family has a faulty marker ALL members will be x-ed out
// at that marker. All members of that pedigree will be marked off the "done_list", we will not consider them again
// during this iteration except as sibling in another generation. I.e. parents might also be siblings and offspring
// might also be parents.
	unsigned char parent1;										// parent IDs of affected. We need those to find: 
	unsigned char parent2;										// a. possible parents of affected to "build" TRIAD
																// b. to find all (unaffected) siblings which will have the same parents/IDs
	int ped_members;											// valid entries in list[]
	unsigned char done_list[largest_pedigee];					// list of individuals that we already looked at in "this" iteration
																// everybody gets looked at at most once per iteration
	unsigned char nuc_list[largest_pedigee];					// as above on nuc.fam level
	int pedlist[largest_nucfam+1];								// holds list of nuclear family,	[0] == parent1
																//									[1] == parent2
																//									[2] == offspring1
																//									etc.							
	int i,j;
	int changes = 1;													// we have to deal with the same pedigree one or more times unless we made no more changes to it
	explode_geno(fa);													// uncompress all genotypes for this pedigree into mrkgeno[indiv][allele], so mrkgeno[max ped size][2*markers]
	while(changes > 0){
		changes = 0;													// reset to zero BEFORe we start looking at pedigree
		i = 0;
		ped_members = 0;
		memset((void*)done_list, 0, largest_pedigee * sizeof(unsigned char));
		while(i < fa.members){											// step through entire pedigree
			parent1 = fa.geno[i][2];
			parent2 = fa.geno[i][3];
			if((parent1 > 0) && (parent2 > 0) && (done_list[i] == 0)){	// both parents exist and we haven't looked at this individual yet
				done_list[i]++;											// done_list[] operates on pedigree level
				memset((void*)pedlist, 0, (largest_nucfam+1) * sizeof(int));
				memset((void*)nuc_list, 0, largest_pedigee * sizeof(unsigned char));
				nuc_list[parent1]++;
				nuc_list[parent2]++;
				nuc_list[i]++;
				pedlist[0] = 3;											// counts individuals
				pedlist[1] = parent1;
				pedlist[2] = parent2;
				pedlist[3] = i;
				j = 0;													// so far we have 2 parents and one offspring. Find all siblings, i.e. complete nuc. family
				while(j < fa.members){									// looking for siblings, i.e. same parents
					if((((fa.geno[j][2] == parent1) && (fa.geno[j][3] == parent2)) || ((fa.geno[j][2] == parent2) && (fa.geno[j][3] == parent1))) && (0 == nuc_list[j])){
						pedlist[0]++;
						pedlist[pedlist[0]] = j;
						done_list[j]++;
						nuc_list[j]++;
					} // if(((fa.geno[j][2] == parent1) && (fa.geno[j][3] == parent2)) || ((fa.g...
					j++;
				} // while(j < fa.members)
				// now need to process that nuclear family
				changes += correct_nuc_fam(pedlist);
			} // if((parent1 > 0) && (parent2 > 0) && (done_list[i] == 0))
			i++;
		} // while(i < fa.members)

	} // while(changes > 0)
}

//************************************

int Consume_data::correct_nuc_fam(int list[])
// list[0] = # of nuc.fam members
// list[1] = p1 (parent 1)
// list[2] = p2 (parent 2)
// list[3] = 1st offspring
// etc.
{
	int errors = 0;
	int i,j;
	int index1, index2;													// indices for alleles 1 & 2
	unsigned char p1a1,p1a2,p2a1,p2a2, oa1,oa2;
	int p1t, p2t;														// parent1_typed, parent2_typed
	int badmrk;
	for(i = 0; i < size; i++){											// step through every marker
		badmrk = 0;														// we stop investigating a marker as soon as we find the 1st inconsistancy
		j = 3;
		index1 = 2 * i;
		index2 = index1 + 1;
		p1a1 = mrkgeno[list[1]][index1];
		p1a2 = mrkgeno[list[1]][index2];
		p2a1 = mrkgeno[list[2]][index1];
		p2a2 = mrkgeno[list[2]][index2];
		p1t = 0;														// assume parent1 not typed
		if(0 < (p1a1 * p1a2)){											// take product of both alleles, if > 0 => typed
			p1t = 1;													// set typed to 1
		}
		p2t = 0;														// ditto parent 2
		if(0 < (p2a1 * p2a2)){
			p2t = 1;
		}
		while((j <= list[0]) && (badmrk == 0)){
			oa1 = mrkgeno[list[j]][index1];
			oa2 = mrkgeno[list[j]][index2];								// now we have the alleles of both parents and offspring
			
		}
	}
	return(errors);
}

//************************************
//*** "_c" functions below ***********

void Consume_data::calculate_c(struct Fam& fa)
{
// OK, we got us a pedigree. We basically need to disect it into all possible triads
// and discordant sib-pairs.
// TRIADS: We basically need to step through all affecteds and see if:
//		- they are typed
//		- BOTH parents are typed
// Discordant SIB-PAIRS: We need to step through all affecteds and see if they have
//	one (or more) unaffected sibling. Both need to be typed.
	int list[3];									// holds the DI# of our subjects
													// TRIADS:	list[0] = parent1
													//			list[1] = parent2
													//			list[2] = aff. offspring
													// DIS.SIB.	list[0] = un aff sib
													//			list[1] = aff. sib.
	int i,j,k;
	int found;
	int max = fa.loci - window + 1;
													// struct Fam.geno ...see below. i = Indiv. ID# starting at 0,...,(fa.members-1) 
													// geno[i][1] = "individual ID"
													// geno[i][2] = "1st parent"
													// geno[i][3] = "2nd parent"
													// geno[i][4] = "male=1,female=2"
													// geno[i][5] = "aff.stat. aff=1,unaff=2,unkown=0"
													// geno[i][6+] = "upper 4 bits allele1, lower 4 bits allele2"
	float d;										// ...yes, that "D": D = [1/(nt+ns)]*{sum_nt(xt) + sum_ns(xs)}
//	float nps;										// "nt + ns"
	unsigned char parent1;									// parent IDs of affected. We need those to find: 
	unsigned char parent2;									// a. possible parents of affected to "build" TRIAD
													// b. to find all (unaffected) siblings which will have the same parents/IDs
	unsigned char parent;										// in case we're only looking for one parent after finding the first one
	int found_triad = 0;							// used for "ana_opt == 3", use only triads unless parent(s) not typed
	for(i = 0; i < max; i++){						// reset all the temp storage for this new pedigree to ZERO
		if(genopdt){
			k = (hfr->numall[i] * (hfr->numall[i] + 1))/ 2;
		}
		else{
			k = hfr->numall[i];
		}
		memset((void*)storage.xst[i], 0, k * sizeof(int));
		memset((void*)storage.yst[i], 0, k * sizeof(int));
	}
	memset((void*)storage.useage, 0, max * sizeof(int));
	memset((void*)storage.nsf, 0, max * sizeof(int));
	memset((void*)storage.ntf, 0, max * sizeof(int));
	memset((void*)sib_list, 0, max_ped_size * sizeof(unsigned char));
	for(i = 0; i < fa.members; i++){
		if((fa.geno[i][5] == affected)/* && (fa.geno[i][6] != 0)*/){	// we got us an affected that is "typed"...well, at least the 1st marker is typed, so we assume the whole thing is typed. If not we will experience a seg. fault
			parent1 = fa.geno[i][2];
			parent2 = fa.geno[i][3];
			if((parent1 != 0) && (parent2 != 0) && (parent1 != parent2)){			// affected founders are useless for our purposes. Both parents MUST exist, not necessarily typed. parent1 != parent2...not possible in humans as far as I know...
				list[0] = i;								// record indiv. ID of affected
// first test for valid triad. i.e. are parents typed?
				found = 0;
				k = 0;
				while((k < fa.members) && (found < 2)){
					if(found == 0){							// need to test both parent IDs
						if(parent1 == fa.geno[k][1]){
							found++;						// OK, we found a parent
							parent = parent2;			// since we found parent1 we're now only looking for #2
							list[1] = k;

						} // end f(parent1 == fa.geno[k][1])
						else if(parent2 == fa.geno[k][1]){
							found++;						// OK, we found a parent
							parent = parent1;			// since we found parent1 we're now only looking for #2
							list[1] = k;

						} // end else if(parent2 == fa.geno[k][1])
					} // end if(found == 0)
					else if(found == 1){					// already found one parent, only looking for one more
						if(parent == fa.geno[k][1]){
							found++;
							list[2] = k;				// super!! found 2nd genotyped parent
						}
					} // end else if(found == 1)
					k++;
				} // end while((k < fa.members) && (found < 2) && valid)
				// ana_pot == 0 => use all info available
				// ana_opt == 1 => only use triads
				// ana_opt == 2 => only use discordant sibs
				if((found == 2) && ((ana_opt == 0) || (ana_opt == 1) || (ana_opt == 3))){					// we found 2 parent that are valid/typed
					if(genopdt == 0){
						calc_triads_c(list, fa);					// do some calculation on that triad
					}
					else{											// do the geno thingy
						calc_geno_triads_c(list, fa);
					}
					found_triad = 1;
				}
// now see if we can squeeze some discordant sib-pairs out of this mess
				k = 0;
				while(k < fa.members){
					if(i != k){
						if(((parent1 == fa.geno[k][2]) && (parent2 == fa.geno[k][3])) || ((parent1 == fa.geno[k][3]) && (parent2 == fa.geno[k][2]))){ // OK we found somebody with the same parents...
							if((fa.geno[k][5] == unaffected) /*&& (fa.geno[k][6] != 0)*/){			// that fella' is typed & unaffected
								list[1] = k;
								if((ana_opt == 0) || (ana_opt == 2) || ((found_triad == 0) && (ana_opt == 3))){
									if(genopdt == 0){
										calc_sibs_c(list, fa);
									}
									else{
										calc_geno_sibs_c(list, fa);
									}
								} // end if((ana_opt == 0) || (ana_opt == 2))
							} // end if((fa.geno[k][5] == unaffected)
						} // end if(((parent1 == fa.geno[k][2]) && (parent2 == fa.geno[k][3])) || (( ...
					} // end if(i != k)
					k++;
				} // end while(k < fa.members)

				
			} // end if((parent1 != 0) && (parent2 != 0))
		} // end if((fa.geno[i][5] == 1) && (fa.geno[i][6] != 0))
	}
	float sandt;
	for(i = 0; i < max; i++){					// now we need to process the Ds into sum(D) & sum(D^2)
			if(genopdt){
				k = (hfr->numall[i] * (hfr->numall[i] + 1)) / 2;
			}
			else{
				k = hfr->numall[i];
			}
			for(j = 0; j < k; j++){
				d = (float)storage.xst[i][j] + (float)storage.yst[i][j];
				if(pdtave){
					sandt = ((float)storage.nsf[i] + (float)storage.ntf[i]);
					if(sandt != 0){
						d /= sandt;
					}
				}
				storage.d[i][j] += d;
				storage.dsq[i][j] += (d * d);
			}
			if(storage.useage[i]){
				storage.fams[i]++;
			}
	} // end for(i = 0; i < fa.loci; i++)
	if(store_d){													// for permutation. Assume only 2 alleles. This will not works with 3 or more alleles the way it is currently implemented since we assume symmetry
		for(i = 0; i < max; i++){
			d = (float)storage.xst[i][0] + (float)storage.yst[i][0];
			if(pdtave){
				sandt = ((float)storage.nsf[i] + (float)storage.ntf[i]);
				if(sandt != 0){
					d /= sandt;
				}
			}
			d_matrix[pedid][i] = d;
		}
	}
}

//************************************

void Consume_data::calc_sibs_c(int list[], struct Fam& fa)
{

	if((fa.geno[list[0]][affection_field] != affected) || (fa.geno[list[1]][affection_field] != unaffected)){ // bogus sibship
		return;
	}
	int i = 0;
	unsigned char aff1;
	unsigned char aff2;
	unsigned char un1;
	unsigned char un2;
	int s0,s1;
	int max = fa.loci - window + 1;
	s0 = list[0];
	s1 = list[1];
	haplotize(fa.geno[s1], indiv2);					// un-affected
	haplotize(fa.geno[s0], indiv1);					// affected
	if(1 == verbose){									// rather duplicate a bunch of code than checking "verbose" every time
		while(i < max){

			// unaff. sib
			un1 = indiv2[0][i];
			un2 = indiv2[1][i];

			// aff. sib
			aff1 = indiv1[0][i];
			aff2 = indiv1[1][i];
			if(!((un1 == 255) || (un2 == 255) || (aff1 == 255) || (aff2 == 255))){
				storage.ns[i] += 1;
				storage.nsf[i] += 1;
				storage.xst[i][aff1] += 1;
				storage.xst[i][aff2] += 1;
				storage.xst[i][un1] -= 1;
				storage.xst[i][un2] -= 1;
				storage.used[i][aff1]++;
				storage.used[i][aff2]++;
				storage.used[i][un1]++;
				storage.used[i][un2]++;
				storage.useage[i]++;
				if(0 == sib_list[s0]){
					storage.sibs_aff[i][aff1]++;
					storage.sibs_aff[i][aff2]++;
				}
				if(0 == sib_list[s1]){
					storage.sibs_una[i][un1]++;
					storage.sibs_una[i][un2]++;
				}
			}
			i++;
		}
		sib_list[s0]++;
		sib_list[s1]++;
	}
	else if(0 == verbose){
		while(i < max){

			// unaff. sib
			un1 = indiv2[0][i];
			un2 = indiv2[1][i];

			// aff. sib
			aff1 = indiv1[0][i];
			aff2 = indiv1[1][i];
			if(!((un1 == 255) || (un2 == 255) || (aff1 == 255) || (aff2 == 255))){
				storage.ns[i] += 1;
				storage.nsf[i] += 1;
				storage.xst[i][aff1] += 1;
				storage.xst[i][aff2] += 1;
				storage.xst[i][un1] -= 1;
				storage.xst[i][un2] -= 1;
				storage.used[i][aff1]++;
				storage.used[i][aff2]++;
				storage.used[i][un1]++;
				storage.used[i][un2]++;
				storage.useage[i]++;
			}
			i++;
		}
	}
}

//************************************

void Consume_data::calc_triads_c(int list[], struct Fam& fa)
{
//struct Fam{								// structure that holds the data
//	int members;						// each Family has 2 parents and "members - 2" children
//	int loci;							// number of loci, kind of redundant since all Fams are going to have the same number
//	unsigned char **geno;				// geno[i][j] is for the ith member and jth locus
										// geno[i][0] holds 0|1. 0 = not genotyped, 1 = valid data
										// geno[members][loci+6]
										// geno[i][1] = "individual ID"
										// geno[i][2] = "1st parent"
										// geno[i][3] = "2nd parent"
										// geno[i][4] = "male=1,female=2"
										// geno[i][5] = "aff.stat. aff=1,unaff=2,unkown=0"
										// geno[i][6+] = "upper 4 bits allele1, lower 4 bits allele2"

//};
// list[0] = AFFECTED offspring. At this point we have to assume that the offspring is affected. The checking needs to take place earlier
// list[1] = parent1
// list[2] = parent2

	if(fa.geno[list[0]][affection_field] != affected){	// offspring not affected. nothing to do
		return;
	}
	int i; 
	int max = fa.loci - window + 1;
	
	unsigned char p1a1;					// parent1,allele1
	unsigned char p1a2;					// parent1,allele2
	unsigned char p2a1;					// parent2,allele1
	unsigned char p2a2;					// parent2,allele2
	unsigned char cha1;					// child, allele1
	unsigned char cha2;					// child, allele2
	
						// ...another triad. Informative or not, we count 'em all...see "PDT-letter to the editor"
	i = 0;
	if(fa.geno[list[1]][4] == 2){						// ...so list[1] is the mother
		haplotize(fa.geno[list[1]], indiv1);			// mother
		haplotize(fa.geno[list[2]], indiv2);			// father		
	}
	else if (fa.geno[list[2]][4] == 2){												// ...else list[2] is the mother
		haplotize(fa.geno[list[1]], indiv2);			// father
		haplotize(fa.geno[list[2]], indiv1);			// mother
	}
	else{
		fprintf(stderr,"Inconsistancy in pedigree %i.\n",fa.id);
	}
	haplotize(fa.geno[list[0]], indiv3);			// affected offspring
	if(0 == verbose){
		while(i < max){
	
		// mother
			p1a1 = indiv1[0][i];
			p1a2 = indiv1[1][i];

		// father
			p2a1 = indiv2[0][i];
			p2a2 = indiv2[1][i];

		// for the aff. child
			cha1 = indiv3[0][i];
			cha2 = indiv3[1][i];

// Assume we have no missing genotypes, otherwise uncomment to code below. It is too time consuming
// to check for this every time. The data arriving here needs to be error free.
//		if((cha1 == 0) || (cha2 == 0) || (p1a1 == 0) || (p1a2 == 0) || (p2a1 == 0) || (p2a2 == 0)){ // we do not deal with missing genotypes
//			return;
//		}
		/*
	for(i = 0; i < max; i++){					// now we need to process the Ds into sum(D) & sum(D^2)
			if(genopdt){
				k = (hfr->numall[i] * (hfr->numall[i] + 1)) / 2;
			}
			else{
				k = hfr->numall[i];
			}
			for(j = 0; j < k; j++){
				d = (float)storage.xst[i][j] + (float)storage.yst[i][j];
				storage.d[i][j] += d;
				storage.dsq[i][j] += (d * d);
			}
			if(storage.useage[i]){
				storage.fams[i]++;
			}
	} // end for(i = 0; i < fa.loci; i++)
	############################
		for(i = 0; i < max; i++){
		if(genopdt == 0){
			s = hfr->numall[i];											// number of alleles
		}
		else{
			s = (hfr->numall[i] * (hfr->numall[i] + 1)) / 2;			// number of geno-types
		}
		for(j = 0; j < s; j++){
			result->data1[i][j] += storage.d[i][j];
			result->data2[i][j] += storage.dsq[i][j];
			result->data3[i][j] += storage.used[i][j]; 
		}
//		if(Consume_data::check){
			result->ns[i] += storage.ns[i];
			result->nt[i] += storage.nt[i];
			result->fams[i] += storage.fams[i];
//		}
		*/

			if(!((cha1 == 255) || (cha2 == 255) || (p1a1 == 255) || (p1a2 == 255) || (p2a1 == 255) || (p2a2 == 255))){ // we do not deal with missing genotypes
				storage.nt[i] += 1;
				storage.ntf[i] += 1;
				storage.yst[i][cha1] += 2;
				storage.yst[i][cha2] += 2;
				storage.yst[i][p1a1] -= 1;
				storage.yst[i][p1a2] -= 1;
				storage.yst[i][p2a1] -= 1;
				storage.yst[i][p2a2] -= 1;
				storage.used[i][cha1]++;
				storage.used[i][cha2]++;
				storage.used[i][p1a1]++;
				storage.used[i][p1a2]++;
				storage.used[i][p2a1]++;
				storage.used[i][p2a2]++;
				storage.useage[i]++;
			}
			i++;
		} // while(i < max)
	} // if(0 == verbose)
	else if(1 == verbose){								// verbose == 1
		while(i < max){
	
		// mother
			p1a1 = indiv1[0][i];
			p1a2 = indiv1[1][i];

		// father
			p2a1 = indiv2[0][i];
			p2a2 = indiv2[1][i];

		// for the aff. child
			cha1 = indiv3[0][i];
			cha2 = indiv3[1][i];

			if(!((cha1 == 255) || (cha2 == 255) || (p1a1 == 255) || (p1a2 == 255) || (p2a1 == 255) || (p2a2 == 255))){ // we do not deal with missing genotypes
				storage.nt[i] += 1;
				storage.ntf[i] += 1;
				storage.yst[i][cha1] += 2;
				storage.yst[i][cha2] += 2;
				storage.yst[i][p1a1] -= 1;
				storage.yst[i][p1a2] -= 1;
				storage.yst[i][p2a1] -= 1;
				storage.yst[i][p2a2] -= 1;
				storage.used[i][cha1]++;
				storage.used[i][cha2]++;
				storage.used[i][p1a1]++;
				storage.used[i][p1a2]++;
				storage.used[i][p2a1]++;
				storage.used[i][p2a2]++;
				storage.useage[i]++;

				storage.triads_trans[i][cha1]++;
				storage.triads_trans[i][cha2]++;
				storage.triads_nottr[i][cha1]--;
				storage.triads_nottr[i][cha2]--;
				storage.triads_nottr[i][p1a1]++;
				storage.triads_nottr[i][p1a2]++;
				storage.triads_nottr[i][p2a1]++;
				storage.triads_nottr[i][p2a2]++;
				if(p1a1 == p1a2){
					storage.homo_par[i][p1a1]++;
				}
				if(p2a1 == p2a2){
					storage.homo_par[i][p2a1]++;
				}
			}
			i++;
		} // while(i < max)
	} // else
}

//************************************
// Here all the geno-PDT functions start
//************************************
void Consume_data::calc_geno_sibs_c(int list[], struct Fam& fa)
{
// list[0] = aff. sib
// list[1] = unaff. sib
	
	if((fa.geno[list[0]][affection_field] != affected) || (fa.geno[list[1]][affection_field] != unaffected)){ // bogus sibship
		return;
	}
	int i = 0;
	int gt1, gt2;
	unsigned char aff1;
	unsigned char aff2;
	unsigned char un1;
	unsigned char un2;
	int max = fa.loci;
	haplotize(fa.geno[list[1]], indiv2);			// un-affected
	haplotize(fa.geno[list[0]], indiv1);			// affected
	while(i < max){
		
		// unaff. sib
		un1 = indiv2[0][i];
		un2 = indiv2[1][i];

		// aff. sib
		aff1 = indiv1[0][i];
		aff2 = indiv1[1][i];

		if(!((un1 == 255) || (un2 == 255) || (aff1 == 255) || (aff2 == 255))){
			storage.ns[i] += 1;
			gt1 = get_genotype(un1, un2, i);
			gt2 = get_genotype(aff1, aff2, i);
			storage.xst[i][gt2] += 1;
			storage.xst[i][gt1] -= 1;
			storage.used[i][aff1]++;
			storage.used[i][aff2]++;
			storage.used[i][un1]++;
			storage.used[i][un2]++;
			storage.useage[i]++;
		}
		i++;
	}
}

//************************************

void Consume_data::calc_geno_triads_c(int list[], struct Fam& fa)
{
//struct Fam{								// structure that holds the data
//	int members;						// each Family has 2 parents and "members - 2" children
//	int loci;							// number of loci, kind of redundant since all Fams are going to have the same number
//	unsigned char **geno;				// geno[i][j] is for the ith member and jth locus
										// geno[i][0] holds 0|1. 0 = not genotyped, 1 = valid data
										// geno[members][loci+6]
										// geno[i][1] = "individual ID"
										// geno[i][2] = "1st parent"
										// geno[i][3] = "2nd parent"
										// geno[i][4] = "male=1,female=2"
										// geno[i][5] = "aff.stat. aff=1,unaff=2,unkown=0"
										// geno[i][6+] = "upper 4 bits allele1, lower 4 bits allele2"

//};
// list[0] = AFFECTED offspring. At this point we have to assume that the offspring is affected. The checking needs to take place earlier
// list[1] = parent1
// list[2] = parent2

	if(fa.geno[list[0]][affection_field] != affected){	// offspring not affected. nothing to do
		return;
	}
	int i, j, k; 
	int max = fa.loci;
	int gt1, gt2;
	unsigned char r[2];					// the "inverse" genotype of "cha1 & cha2"
	unsigned char p1a1;					// parent1,allele1
	unsigned char p1a2;					// parent1,allele2
	unsigned char p2a1;					// parent2,allele1
	unsigned char p2a2;					// parent2,allele2
	unsigned char cha1;					// child, allele1
	unsigned char cha2;					// child, allele2
	
						// ...another triad. Informative or not, we count 'em all...see "PDT-letter to the editor"
	i = 0;
	if(fa.geno[list[1]][4] == 2){						// ...so list[1] is the mother
		haplotize(fa.geno[list[1]], indiv1);			// mother
		haplotize(fa.geno[list[2]], indiv2);			// father		
	}
	else if (fa.geno[list[2]][4] == 2){												// ...else list[2] is the mother
		haplotize(fa.geno[list[1]], indiv2);			// father
		haplotize(fa.geno[list[2]], indiv1);			// mother
	}
	else{
		fprintf(stderr,"Inconsistancy in pedigree %i.\n",fa.id);
	}
	haplotize(fa.geno[list[0]], indiv3);			// affected offspring
	while(i < max){
		memset((void*)genostore, 0, max_geno * sizeof(int));				// reset the bean counter to zero
		// mother
		p1a1 = indiv1[0][i];
		p1a2 = indiv1[1][i];

		// father
		p2a1 = indiv2[0][i];
		p2a2 = indiv2[1][i];

		// for the aff. child
		cha1 = indiv3[0][i];
		cha2 = indiv3[1][i];

// Assume we have no missing genotypes, otherwise uncomment to code below. It is too time consuming
// to check for this every time. The data arriving here needs to be error free.
//		if((cha1 == 0) || (cha2 == 0) || (p1a1 == 0) || (p1a2 == 0) || (p2a1 == 0) || (p2a2 == 0)){ // we do not deal with missing genotypes
//			return;
//		}
			if(!((cha1 == 255) || (cha2 == 255) || (p1a1 == 255) || (p1a2 == 255) || (p2a1 == 255) || (p2a2 == 255))){ // we do not deal with missing genotypes
				storage.nt[i] += 1;
				genostore[p1a1]++;
				genostore[p1a2]++;
				genostore[p2a1]++;
				genostore[p2a2]++;
				genostore[cha1]--;
				genostore[cha2]--;
				j = 0;
				k = 0;
				while(j < 2){							// now get the "inverse" genotype from genostore[]
					if(genostore[k] > 0){				// also note: VALID alleles start at 0, not 1. missing data is 255
						r[j] = k;
						genostore[k]--;
						j++;
						if(genostore[k] > 0){				// also note: VALID alleles start at 0, not 1. missing data is 255
							r[j] = k;
							genostore[k]--;
							j++;
						}
					}
					k++;
				}
				gt2 = get_genotype(cha1, cha2, i);
				gt1 = get_genotype(r[0], r[1], i);
				storage.yst[i][gt2] += 1;
				storage.yst[i][gt1] -= 1;
				storage.used[i][cha1]++;
				storage.used[i][cha2]++;
				storage.used[i][p1a1]++;
				storage.used[i][p1a2]++;
				storage.used[i][p2a1]++;
				storage.used[i][p2a2]++;
				storage.useage[i]++;
			}
		i++;
	}
}

//************************************

int Consume_data::get_genotype(unsigned char a1, unsigned char a2, int mrk)
{
	int max_all = fr->numall[mrk];
	int sm;									// allele with smaller number
	int large;								// allele with larger or equal number. We  want "12", not "21"
	int base = 0;
	int diff = 0;
	int result;
	if(a1 < a2){
		sm = a1;
		large = a2;
	}
	else{
		sm = a2;
		large = a1;
	}
	diff = large - sm;
	while(sm > 0){
		base += max_all;
		max_all--;
		sm--;
	}
	result = base + diff;
	return(result);
}

//************************************


