#ifndef __CONSUMER_SYNC__
#define __CONSUMER_SYNC__

#ifdef WIN32
#include "pthread.h"
#include "sched.h"
#include "semaphore.h"
#include <windows.h>
#endif
#ifdef SOLARIS
#include <pthread.h>			// define _REENTRANT in makefile
#include <string.h>
#endif

struct Result{
	int pedigrees;							// init to 0, increment by one for each pedigree processed
	int size;								// number of loci & of pointer below
	float **data1;							// init this to all zeros. Each consumer gets to update this with their own data (also of type "struct Result"
	float **data2;
	int **data3;							// useage count for each allele. Annoying, but we must keep track how often it occured in our stats. Can't include it if it never occured							
// only used in verbose mode //
	int **data4;							// aff sibs count in marker and alleles
	int **data5;							// unaff sibs count in marker and alleles
	int **data6;							// transmitted count in triads
	int **data7;							// NOT transmitted count in triads
	int **data8;							// to capture homo-zygot parents
// end verbose //
	int *nt;								// # of triads
	int *ns;								// # of discordant sib-pairs
	int *fams;								// counter for families used
	pthread_mutex_t mut_consumer;			// lock if "Global_data" is updated, that's only between competing consumers
};

struct Freq{
	int *numall;							// # of alleles for ith locus
	float **afreq;							// freq. of marker alleles, sum == 1
};


#endif
