#ifndef __DATA_H__
#define __DATA_H__

const int max_file_name = 1024;

struct Data{
	char *pedfile;			// 3 files for imput format 1
	char *mapfile;
	char *freqfile;
	char *genefile;			// contains stuff like: EPHB2 1 23037330 23241822
	char *sindexfile;		// file with the effective gene size (some integer). Entries must have same order as genes in "genefile"
	char *pathwayfile;		// file that has all pathways. looks like:  28  RPS25 RPS14 RPS6
	char *outfile_mrk;		// outfiles
	char *specialmrklist;
	int inputformat;		// 1 = usual .ped format, 2 = PLINK bed/bim/fam, 4 = atcg
	char *plinkbim;			// the 3 PLINK imput files 
	char *plinkbed;
	char *plinkfam;
	int printbymrk;			// print by marker outfile
	int usemapfile;			// 0 = do not use mapfile, 1 = use mapfile
	int usefreqfile;		// 0 = do not use freq file, 1 = use freqfile
	int usespecialmrk;		// 0 = do not use, 1 = look in special marker list if this marker is supposed to be printed will all detail
	int nmf;				// noo marker fields, usually 6
	int window;				// 1 for single marker
	int genopdt;			// 1 = geno-PDT, 0 = regular PDT
	int max_cpus;
	int permutations;		// number of permutations
	int verbose;			// prints out all kinds of info about transmitted/not transmitted
	int options;			//0=use all info; 1=triads only; 2=sibs only; 3=only triads if available
	int permute;			// 0 = do not permute, N > 1 = permute N-times, N = {1,2,3,...}
	int maxfamsize;			// size of largest pedigree in .ped file
	int pdtave;				// use PDT average 0|1
	int printnew;			// 0|1 print new, smaller .map and .ped files?
	int genebuf;			// base pairs at each end of the gene to be included when trying to find SNPs that are in that gene
};

#endif
