#ifndef __HASH_TABLE__
#define __HASH_TABLE__

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

const float tablecoeff = 1.25;

struct Hrecord{
	char *key;
	int value;
};

struct SNPnode{
	int snp_index;
	SNPnode *next;
};

struct Generecord{
	float best_pdt;
	int snpsingene;
	int *snplist;
};

struct Gene{
	unsigned char chrom;
	unsigned int start;
	unsigned int stop;
	unsigned int snps;
	float best_pdt;
	SNPnode *head;
};

class HT{
public:
	HT();
	~HT();
	int next_larger_prime(int);
	int insertrecord(char*,int);							// returns key (>= 0) of record, -1 if not found 
	int queryrecord(char*);							// similar as insertrecord but will not add record to table. Returns index or -1 if not in table
	int numberofentries();								// returns number of valid entries in table
	void inittable(int);								// enter an estimate of the number of expected entries
	int hfn(char*);


private:
	int entries;
	int tablesize;
	Hrecord *table;
};

#endif
