#ifndef __HELP_H__
#define __HELP_H__

const char reference[1000] = {"Reference:\nEden R. Martin, S. Monks, L. Warren, N. Kaplan (2000)\nA Test for Linkage and Association in General Pedigrees:\nThe Pedigree Disequilibrium Test.\nAm. J. Hum. Genet. 67:146-154, 2000\n"};
const char letterto[1000] = {"Letter to the Editor: Correcting for a Potential Bias in the Pedigree Disequilibrium Test\nAm. J. Hum. Genet. 68:1065-1067, 2001\n"};
const char help[3000] = "# This line is a comment, it must begin with #\n#file that contains genotypes\npedigree_file:                   13.ped\n#map file: <chrom. number> <rs-number> <physical location> optional 4th field: <number of alleles if >= 3>\nmap_file:                           13map.txt\n# Result file\noutfile:           pdt2_pathway.out\n# The fields in the .ped file that are not alleles. Usually 6, when using SIMLA 8\nnon_maker_fields:          8\n# Number of CPUs that PDT2 will try to use.\nmax_cpus:                         1\n# 0=use all info; 1=triads only; 2=sibs only; 3=only triads if available, otherwise use discordant sibs\noptions:                              0\n# size of largest pedigree in .ped file. Going under will cause crash, going over will waste some memory.\nmax_permutations:        1000\n# file containing gene ranges\ngene_file:                             gene_pos.new\n#buffer on each side of gene additional to range\ngene_buffer:                           20000\nmax_fam_size:                  8\npathway_file:                         pathway.txt\n# verbose option will print additional information, 0|1\nverbose:                  1\n";

//const char help[3000] = {""}; // {"PDT2 takes 9 command line arguments:\ninfile.ped:     File that contains the Pedigree information\n                All fields are seperated by one or more whitespaces. File format is as follows:\n                - Pedigree ID\n                - Individual ID\n                - ID of parent 1, 0 if unavailable\n                - ID of parent 2, 0 if unavailable\n                - sex, 1 = male, 2 = female, 0 = unkown\n                - affection status, 1 = unaff., 2 = aff., 0 = unkown\n                - possibly \"n\" other fields containing info irrelevant to PDT2\n                - Marker info, 2 alleles per marker\ninfile.dat      File that contains info on markers and alleles.\n                File format is as follows:\n                M  <optional marker name for marker_1>\n                F  <optional frequency of allele_1>\n                ...\n                F  <optional frequency of allele_k>\n                ...\n                M  <optional marker name for marker_n>\n                F  <optional frequency of allele_1>\n                ...\n                F  <optional frequency of allele_k>\nsize_of_largest_pedigree\n                Warning: choosing too small of a size will lead to program crash\n                Choosing too large of a size will waste memory\noutfile name\noutfile         Name of the file results will be printed.\nnon-marker-fields\n                The total number of fields at the beginning of each line in the\n                pedigree file that are not alleles.\n				Refering to the above, that would be \"6+n\"\nOptional parameters:\nsliding_window_size, default == 1\n                Use 1 for single locus analysis.\n                2 through 7 for haplotypes consisting of 2 through 7 adjacent loci.\n				Obviously if you have n-loci total and test k-loci haplotypes,\n                there will be \"n-k+1\" such haplotypes.\ncheck_if_typed, default is check if typed\n                Check for each locus if all individuals are typed. Useful for real data\n                but a bit slower. So only use if necessary.\nmax_cpus, default == 4. Only set this to 1 for debugging. Otherwise use any number bigger or\n                equal to the number of actual CPUs on your machine\nana_opt, default == 0. Analysis option\n                0 == use all available info\n                1 == triads only\n                2 == discordant sibpairs only\n"};


#endif
/*
"PDT2 takes 9 command line arguments:\n
infile.ped:     File that contains the Pedigree information\n                All fields are seperated by one or more whitespaces. File format is as follows:\n                - Pedigree ID\n                - Individual ID\n                - ID of parent 1, 0 if unavailable\n                - ID of parent 2, 0 if unavailable\n                - sex, 1 = male, 2 = female, 0 = unkown\n                - affection status, 1 = unaff., 2 = aff., 0 = unkown\n                - possibly \"n\" other fields containing info irrelevant to PDT2\n                - Marker info, 2 alleles per marker\n
infile.dat      File that contains info on markers and alleles.\n                File format is as follows:\n                M  <optional marker name for marker_1>\n                F  <optional frequency of allele_1>\n                ...\n                F  <optional frequency of allele_k>\n                ...\n                M  <optional marker name for marker_n>\n                F  <optional frequency of allele_1>\n                ...\n                F  <optional frequency of allele_k>\n
size_of_largest_pedigree\n                Warning: choosing too small of a size will lead to program crash\n                Choosing too large of a size will waste memory\noutfile name\n
outfile         Name of the file results will be printed.\n
non-marker-fields\n                The total number of fields at the beginning of each line in the\n                pedigree file that are not alleles.\n				Refering to the above, that would be \"6+n\"\n
Optional parameters:\n
sliding_window_size, default == 1\n                Use 1 for single locus analysis.\n                2 through 7 for haplotypes consisting of 2 through 7 adjacent loci.\n				Obviously if you have n-loci total and test k-loci haplotypes,\n                there will be \"n-k+1\" such haplotypes.\n
check_if_typed, default is check if typed\n                Check for each locus if all individuals are typed. Useful for real data\n                but a bit slower. So only use if necessary.\n
max_cpus, default == 4. Only set this to 1 for debugging. Otherwise use any number bigger or\n                equal to the number of actual CPUs on your machine\n
ana_opt, default == 0. Analysis option\n                0 == use all available info\n                1 == triads only\n                2 == discordant sibpairs only\n");
*/
