#include "param.h"

//**************************************

Param::Param()
{

}

//**************************************

Param::~Param()
{

}

//**************************************

void Param::ptr_to_buffer(char *ptr, char buffer[], int size)
{
	int i = 0;
	while((i < (size-1)) && ('\0' != *(ptr+i))){
		buffer[i] = *(ptr+i);
		i++;
	}
	buffer[i] = '\0';
}

//**************************************

long Param::find_file_pos(ifstream &search_file, const char find_me[], long start)
{
	long result = -1;			// return value if string not found
	static long current = 0;
	long temp;
	int not_found = 0;
	int loop_around;
	int passed_eof = 0;

	char line[max_rdln];
	char *substrptr;
	if(start >= 0){
		current = start;
	}
	else{
		start = current;
	}
	loop_around = start;
	if((search_file.is_open()) && (strlen(find_me) > 0)){
		search_file.clear();
		search_file.seekg(start, ios::beg);
		while((result == -1) && (not_found == 0) /*(!(search_file.eof()))*/){
			if(search_file.eof()){
				search_file.clear();
				search_file.seekg(0, ios::beg);
				passed_eof++;
				current = 0;
			}
		    search_file.getline(line, max_rdln);
			substrptr = NULL;
			if(line[0] != '#'){					// indicates a comment. We don't consider this line
				substrptr = strstr(line, find_me);
			}
			if(substrptr == NULL){
#if defined (WIN32) 
				current += strlen(line) + 2;  // +2 for '\0' on DOS format
#endif
#if defined (SOLARIS) || defined (LINUX) || defined (OSX)
				current += strlen(line) + 1;  // +1 for '\0' 
#endif
			}
			else{
				temp = (substrptr - line) / sizeof(char);
				result = current + temp;
			}
			if((passed_eof == 1) && (current > loop_around)){      // we looped around 1 full time and still didn't find the string we're lookin for, time to quit
				not_found = 1;
			}
		}
		search_file.clear();
	}
	else{
		cerr << "Param::find_file_posCould not open infile or empty string, exiting." << endl;
	}
	return result;                     
}

//**************************************

long Param::find_file_pos(fstream &search_file, const char find_me[], long start)
{
	long result = -1;			// return value if string not found
	static long current = 0;
	long temp;
	int not_found = 0;
	int loop_around;
	int passed_eof = 0;

	char line[max_rdln];
	char *substrptr;
	if(start >= 0){
		current = start;
	}
	else{
		start = current;
	}
	loop_around = start;
	if((search_file.is_open()) && (strlen(find_me) > 0)){
		search_file.clear();
		search_file.seekg(start, ios::beg);
		while((result == -1) && (not_found == 0) /*(!(search_file.eof()))*/){
			if(search_file.eof()){
				search_file.clear();
				search_file.seekg(0, ios::beg);
				passed_eof++;
				current = 0;
			}
		    search_file.getline(line, max_rdln);
			substrptr = NULL;
			if(line[0] != '#'){
				substrptr = strstr(line, find_me);
			}
			if(substrptr == NULL){
#if defined (WIN32) 
				current += strlen(line) + 2;  // +2 for '\0' on DOS format
#endif
#if defined (SOLARIS) || defined (LINUX) || defined (OSX)
				current += strlen(line) + 1;  // +1 for '\0' 
#endif
			}
			else{
			  temp = (substrptr - line) / sizeof(char);
                    result = current + temp;
			}
			if((passed_eof == 1) && (current > loop_around)){      // we looped around 1 full time and still didn't find the string we're lookin for, time to quit
				not_found = 1;
			}
		}
		search_file.clear();
	}
	else{
		cerr << "Param::find_file_posCould not open infile or empty string, exiting." << endl;
	}
	return result;                             
}

//**************************************
