#ifndef __PARAMETERS_H__
#define __PARAMETERS_H__

#include <iostream>
#include <fstream>
#include <string.h>
#include <stddef.h>
#include <iomanip>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <stdio.h>

using namespace std;

#include "data.h"

#if defined (SOLARIS) || defined (LINUX) || (WIN32)
#include <malloc.h>	
#endif

#if defined (OSX)
#include <malloc/malloc.h>	
#endif

#if defined (SOLARIS) || defined (OSX) || defined (OSX) || defined (LINUX)
	#include <sstream>
	#include <backward/strstream>
	using std::ostrstream;
#endif

#if defined (WIN32)
	#include <strstream>
#endif

const int max_rdln = 1024;

const char inputformat[max_file_name] = "inputformat:";					// 1 = standard, 2 = plink bim/bed/fam
const char nonmarkerfields[max_file_name] = "non_marker_fields:";		// input format 1
const char pedigreefile[max_file_name] = "pedigree_file:";				// input format 1
const char mapfile[max_file_name] = "map_file:";						// input format 1
const char freqfile[max_file_name] = "freq_file:";						// input format 1
const char plinkfiles[max_file_name] = "plink_bed_bim_fam:";			// input format 2
const char outfilebymarker[max_file_name] = "outfile:";
const char windows[max_file_name] = "window:";
const char genopdts[max_file_name] = "geno_pdt:";
const char maxcpuss[max_file_name] = "max_cpus:";
const char optionss[max_file_name] = "options:";
const char maxfamsize[max_file_name] = "max_fam_size:";
const char verbose[max_file_name] = "verbose:";
const char specialmrklist[max_file_name] = "special_mrk_list:";
const char permutation[max_file_name] = "permute:";
const char pdt_stat[max_file_name] = "pdt_average:";
const char genefile[max_file_name] = "gene_file:";
const char genebuffer[max_file_name] = "gene_buffer:";
const char pathwayfile[max_file_name] = "pathway_file:";
const char sindexfile[max_file_name] = "sindex_file:";
const char printnew[max_file_name] = "print_new_map_ped:";
const char maxpermutations[max_file_name] = "max_permutations:";

class Param{

public:
	Param();
	~Param();
	long find_file_pos(ifstream&, const char[], long); 
	long find_file_pos(fstream&, const char[], long); 
//	int str_to_int(char[], int&);	
	void ptr_to_buffer(char *ptr, char buffer[], int size);
//	char* pad_string(ostrstream&, int length);
};

#endif
