#ifndef __PATH_H__
#define __PATH_H__

#include "main.h"

struct pathway_info{
	int num_threads;					// we need to know how many to start
	int id;
	int num_loci;
	int num_genes;
	int num_pathway;
	int num_pedigrees;
	int permutations;
	int verbose;
};

extern float **d_matrix;
extern struct Result *result;
extern int **p_index;
extern int **g_index;
extern short *s_index;
extern double **random_sets;
extern char **rs_marker_names;
extern char **pathway_names;
extern float *ES;
extern float **ES_P;
extern struct Sync_pathway *sync_pathway;
extern int *toll1;
extern int *toll2;

class pathway_class{
public:
	pathway_class();
	~pathway_class();
	void run(struct pathway_info *arg);											// basically the "main()" of the APL class. This is the entry point when the tread gets started.
	void init(struct pathway_info *arg);
	void calculate_pdt_stats(int,int);
	void calculate_gene_scores(int);
	void calculate_ES_scores(int);
	void permute(int,int,int);
	double getran();

/*
	void cdfchifn(int *which,double *p,double *q,double *x,double *df,int *status,double *bound);
	double spmpar(int *i);
	void cumchi(double *x,double *df,double *cum,double *ccum);
	void dstinv(double *zsmall,double *zbig,double *zabsst,double *zrelst,double *zstpmu,double *zabsto,double *zrelto);
	void dinvr(int *status,double *x,double *fx,unsigned long *qleft,unsigned long *qhi);
	void E0000(int,int*,double*,double*,unsigned long*,unsigned long*,double*,double*,double*,double*,double*,double*,double*);
	void E0001(int IENTRY,int *status,double *x,double *fx,double *xlo,double *xhi,unsigned long *qleft,unsigned long *qhi,double *zabstl,double *zreltl,double *zxhi,double *zxlo);
	int ipmpar(int *i);
	void cumgam(double*,double*,double*,double*);
	void ftnstop(char* msg);
	double fifdmax1(double,double);
	double fifdmin1(double,double);
	void dstzr(double *zxlo,double *zxhi,double *zabstl,double *zreltl);
	void dzror(int *status,double *x,double *fx,double *xlo,double *xhi,unsigned long *qleft,unsigned long *qhi);
	double stvaln(double *p);
	double dinvnr(double *p,double *q);
	void cumnor(double *arg,double *result,double *ccum);
	void gratio(double *a,double *x,double *ans,double *qans,int *ind);
	double devlpl(double a[],int *n,double *x);
	double fifdint(double a);
	double gam1(double *a);
	double Xgamm(double *a);
	double rlog(double *x);
	double fifdsign(double mag,double sign);
	long fifidint(double a);
	long fifmod(long a,long b);
	double rexp(double *x);
	double erfc1(int *ind,double *x);
	double erf1(double *x);
	double exparg(int *l);
	double rlog1(double *x);
*/

private:
	int id;
	int permute_no;
	int permutations;									// user specified number of permutations
	int num_loci;
	float *pdt_stats;
	int num_genes;
	int num_pathway;
	float *gene_score;
	float *gene_score_id;
	unsigned short *ranking;
	int num_pedigrees;
	int *index;
	double *randomnumbers;
	int verbose;
};

#endif
