#ifndef __PEDF_H__
#define __PEDF_H__

#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
using namespace std;

const int maxnamesizepf = 1024;
const char blank = ' ';
const int plinkoffset = 3;

struct Pedfinfo{
	char *infile_name_ped;
	char *infile_name_list;
	char *outfile_name_ped;
	char *outfile_name_list;
	char *bimfile;
	char *bedfile;
	char *famfile;
	int non_marker_fields;
	unsigned int options;
};

class PedFiles{
public:
	PedFiles();
	~PedFiles();
	void run(struct Pedfinfo*);
	void getdimensions(int &columns, int &rows);
	void readwritepedfile();								// reads normal a,t,c,g .ped file and changes it to 0,1,2 style
	void readwriteplink();									// read PLINK bim,bed,fam files and makes standard 0,1,2 ped file
	int getsnps();											// read plink.bim to get number of SNPs
	int getindiv();											// reads plink.fam to get number of individuals
	void bim2map(char *outfile);							// reads plink.bim and produces a standard 3 column map file (chrom, name, location) with chrom ==1 and loc. = {1,2,3,...,n}

private:
	char *infileped;
	char *infilelist;
	char *outfileped;
	char *outfilelist;
	char *bimfile;
	char *bedfile;
	char *famfile;
	int non_marker_fields;									// PED_id, indiv_id, etc. fields that describe indivdual, affection status...					
	char *line;												// just temp space to read input from test file
	int rows;												// = number of individuals
	int columns;											// columns or SNPs in .ped file. Assumtion is that this number is the same for all individuals, otherwise crash											
	int snps;												// number of SNPs in ped file
	int indiv;												// number of individuals
	unsigned int options;									// user selected options
	char **asciidata;										// holds ASCII data from entire .ped file
	char *one;												// the symbol for allele "1"
	char *two;												// the symbol for allele "2"
	int maxlinesize;										// max size for line
};

#endif
