#ifndef __READ_DATA__
#define __READ_DATA__

#include <stdio.h>
#include <string.h>
#include "read_sync.h"		// holds data structure to syncronize reader/consumer behaviour
#include "main.h"
#include <iostream>
#include <fstream>
using namespace std;

const int max_name = 1024;
const int freebe = 500;							// we only allow 4bytes per locus + freebe to take care of all else
extern struct Read_sync *read_synchronizer;		// global variable needed for synchronization
extern struct Fam *families;					// will hold data we read from infile

class Read_data{
public:
	Read_data();
	~Read_data();
	void init(char*, int num_of_loci, int line_size, int non_allele_fields, int max_fam_size);
	void run();									// manages the synchronization
	int read_fam(int i, ifstream&);				// does the actual reading from file & processing
												// It will put its data in the ith slot in the "Fam" structure	
												// returns the number of lines successfully read. if 0, then error or EOF
	int process(char*, unsigned char*);			// pick the read in string apart
	
private:
	char infile[max_name];
	int non_allele_fields;	// number at beginning of line desribing stuff other than alleles (like pedID, sex, aff-status etc.)
	int loci;				// number of loci
	char *line;				// this initially holds the line read in from the .ped file
							// since alleles are sperated by ONE (not 2 or 3 or more) whitespace
							// will will have 4 bytes/char per locus, plus pedigree ID and all the other stuff
							// at the beginning of each line...say 100 char, max. So total we would have
							// "100 + 4 * loci" total characters in a line, where loci might be up to 50000.
	int size;				// = 100 + 4 * loci
	int max_fam_size;		// maximum allowable size of any pedigree. We need to know how much memory to allocate. If family_size > max_fam_size => bye,bye
	char *famid;			// pedigree ID
};

#endif
