#ifndef __READPARAM_H__
#define __READPARAM_H__

#include "param.h"                  // common to readparam and write param
#include "pedfiles.h"
#include "constants.h"

class Readparam : public Param{

public:
	Readparam();
	~Readparam();
	void set_file_name(char[]);                      // sets nane of private member "filename" name
	int open_infile(ifstream&);                      // this one does NOT asks for filename, use set_file_name 1st
	struct Data* master_reader(char filename[]);
	void read_non_maker_fields(ifstream&, int&);
	void read_pedigreefile(ifstream&, char*);
	int read_mapfile(ifstream&, char*);
	int read_freqfile(ifstream&, char*);
	int read_genefile(ifstream&, char*);
	int read_sindexfile(ifstream&, char*);
	int read_outfilebymarker(ifstream&, char*);

	int read_pathwayfile(ifstream&, char*);
	void read_plink(ifstream&, char*, char*, char*);
	void read_window(ifstream&, int&);
	void read_genopdt(ifstream&, int&);
	void read_inputformat(ifstream&, int&);
	void read_maxcpus(ifstream&, int&);
	void read_options(ifstream&, int&);
	void read_maxfamsize(ifstream&, int&);
	void read_max_permutations(ifstream&, int&);
	void read_permute(ifstream&, int&);
	void read_verbose(ifstream&, int&);
	void read_pdtave(ifstream&, int&);
	void read_printnew(ifstream&, int&);
	void read_genebuffer(ifstream&, int&);
	int read_specialmrklist(ifstream&, char*);

private:
	char filename[max_file_name];
};

#endif
