#include "read_param.h"

//**************************************

Readparam::Readparam()
{

}

//**************************************

Readparam::~Readparam()
{

}

//**************************************

void Readparam::set_file_name(char name[])
{
	strcpy(filename, name);
}

//**************************************

int Readparam::open_infile(ifstream& infile)
{
	infile.open(filename, ios::in);
	if (infile.is_open()){
		return(1);
	}
	else{
		return(0);
	}
}

//**************************************

struct Data* Readparam::master_reader(char filename[])
{
	PedFiles pfiles;
	struct Pedfinfo pfiles_arg;
	ifstream infile;
	set_file_name(filename);
	struct Data* pdt2data = new struct Data;
	pdt2data->freqfile = new char[max_file_name];
	pdt2data->mapfile = new char[max_file_name];
	pdt2data->outfile_mrk = new char[max_file_name];

	pdt2data->pedfile = new char[max_file_name];
	pdt2data->specialmrklist = new char[max_file_name];
	pdt2data->plinkbed  = new char[max_file_name];
	pdt2data->plinkbim  = new char[max_file_name];
	pdt2data->plinkfam  = new char[max_file_name];
	pdt2data->genefile  = new char[max_file_name];
	pdt2data->sindexfile = new char[max_file_name];
	pdt2data->pathwayfile = new char[max_file_name];
	pdt2data->freqfile[0] = '\0';
	pdt2data->mapfile[0] = '\0';
	pdt2data->outfile_mrk[0] = '\0';
	pdt2data->pedfile[0] = '\0';
	pdt2data->usefreqfile = 0;
	pdt2data->usemapfile = 0;
	pdt2data->verbose = 0;
	pdt2data->pdtave = 0;
	pdt2data->printbymrk = 0;
	pdt2data->inputformat = 1;
	pdt2data->nmf = 6;

	if(!open_infile(infile)){
		cout << "Readparam::master_reader. Can not open PDT control file "<< infile <<" Bailing out.\n";
		exit(0);
	}
	read_inputformat(infile, pdt2data->inputformat);
	read_non_maker_fields(infile, pdt2data->nmf);
	if((pdt2data->inputformat == 2) || (pdt2data->inputformat == 4)){
		pfiles_arg.bedfile = new char[max_rdln];
		pfiles_arg.bimfile = new char[max_rdln];
		pfiles_arg.famfile = new char[max_rdln];
		pfiles_arg.outfile_name_ped = new char[max_rdln];
		pfiles_arg.infile_name_ped = new char[max_rdln];
		pfiles_arg.infile_name_list = new char[max_rdln];
		pfiles_arg.outfile_name_list = new char[max_rdln];
		pfiles_arg.infile_name_ped[0] = '\0';
		pfiles_arg.infile_name_list[0] = '\0';
		pfiles_arg.outfile_name_list[0] = '\0';
		pfiles_arg.non_marker_fields = pdt2data->nmf;
		
	}
	pdt2data->usespecialmrk = read_specialmrklist(infile, pdt2data->specialmrklist);
	if((pdt2data->inputformat == 1) || (pdt2data->inputformat == 4)){
		read_pedigreefile(infile, pdt2data->pedfile);
		pdt2data->usemapfile = read_mapfile(infile, pdt2data->mapfile);	
		if(pdt2data->usemapfile == 0){											// we prefer the map file but will take the .freq file
			pdt2data->usefreqfile = read_freqfile(infile, pdt2data->freqfile);
			pdt2data->printbymrk = 0;
			if(pdt2data->verbose)
				fprintf(stderr,"Readparam::master_reader. Can not print by marker if the .freq file option is selected.");
		}
		if(pdt2data->inputformat ==  4){
			pfiles_arg.options = 1;
			strcpy(pfiles_arg.infile_name_ped, pdt2data->pedfile);
			strcpy(pfiles_arg.infile_name_list, pdt2data->mapfile);
			strcpy(pfiles_arg.outfile_name_ped, "pdt2.ped");
			strcpy(pfiles_arg.outfile_name_list, "pdt2.lst");
			pfiles.run(&pfiles_arg);
			strcpy(pdt2data->pedfile, "pdt2.ped");
		}
	}
	else if(pdt2data->inputformat ==  2){
		read_plink(infile, pdt2data->plinkbed, pdt2data->plinkbim, pdt2data->plinkfam);
		strcpy(pdt2data->mapfile, "pdt2.map");
		pdt2data->usemapfile = 1;
		/*
	strcpy(PedFiles::infileped, arg->infile_name_ped);
	strcpy(PedFiles::infilelist, arg->infile_name_list);
	strcpy(PedFiles::outfileped, arg->outfile_name_ped);
	strcpy(PedFiles::outfilelist, arg->outfile_name_list);
	strcpy(PedFiles::bedfile, arg->bedfile);
	strcpy(PedFiles::bimfile, arg->bimfile);
	strcpy(PedFiles::famfile, arg->famfile);
		*/
		strcpy(pdt2data->pedfile, "pdt2.ped");
		pfiles_arg.options = 2;
		strcpy(pfiles_arg.bedfile, pdt2data->plinkbed);
		strcpy(pfiles_arg.bimfile, pdt2data->plinkbim);
		strcpy(pfiles_arg.famfile, pdt2data->plinkfam);
		strcpy(pfiles_arg.outfile_name_ped, "pdt2.ped");
		pfiles.run(&pfiles_arg);										// creates pdt2.ped
		pfiles.bim2map("pdt2.map");										// creates pdt2.map
	}

	read_verbose(infile, pdt2data->verbose);
	pdt2data->printbymrk = read_outfilebymarker(infile, pdt2data->outfile_mrk);
	read_genefile(infile, pdt2data->genefile);
	read_sindexfile(infile, pdt2data->sindexfile);
	read_pathwayfile(infile, pdt2data->pathwayfile);
	read_genebuffer(infile, pdt2data->genebuf);
	read_window(infile, pdt2data->window);
	read_genopdt(infile, pdt2data->genopdt);
	read_pdtave(infile, pdt2data->pdtave);
	read_printnew(infile, pdt2data->printnew);
	read_maxcpus(infile, pdt2data->max_cpus);
	read_max_permutations(infile, pdt2data->permutations);
	read_permute(infile, pdt2data->permute);
	read_options(infile, pdt2data->options);
	read_maxfamsize(infile, pdt2data->maxfamsize);
	infile.close();
	if(pdt2data->genopdt && pdt2data->verbose){
		fprintf(stderr,"Readparam::master_reader. Verbose mode only implemented with regular PDT, not genoPDT.\n");
		pdt2data->verbose = 0;
	}
	return(pdt2data);
}

//**************************************

void Readparam::read_non_maker_fields(ifstream& infile, int& nmf)
{
	long position;
	position = find_file_pos(infile, nonmarkerfields, 0);
	if(position >= 0){
		position += strlen(nonmarkerfields);
		infile.seekg(position, ios::beg);
		infile >> nmf;
	}
	else{
		cerr <<"Readparam::read_non_maker_fields . Could not find "<<nonmarkerfields<<". Default set to 6"<<endl;
		nmf = 6;
	}
}

//**************************************

void Readparam::read_pedigreefile(ifstream& infile, char *ptrchar)
{
	long position;
	position = find_file_pos(infile, pedigreefile, 0);
	if(position >= 0){
		position += strlen(pedigreefile);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
	}
	else{
		cerr <<"Readparam::read_pedigreefile. Unable to find file name for pedigree file. Bailing out!"<<endl;
		exit(0);
	}
}

//**************************************

int Readparam::read_mapfile(ifstream& infile, char *ptrchar)
{
	long position;
	int result;
	position = find_file_pos(infile, mapfile, 0);
	if(position >= 0){
		position += strlen(mapfile);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	else{
//		cerr <<"Readparam::read_mapfile. Unable to find file name for map file. Trying .freq file!"<<endl;
		result = 0;
	}
	return(result);
}

//**************************************

int Readparam::read_freqfile(ifstream& infile, char *ptrchar)
{
	long position;
	int result = 0;
	position = find_file_pos(infile, freqfile, 0);
	if(position >= 0){
		position += strlen(freqfile);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	else{
		cerr <<"Readparam::read_freqfile. Unable to find file name for .freq file. Bailing out!"<<endl;
		exit(0);
	}
	return(result);
}

//**************************************

int Readparam::read_genefile(ifstream& infile, char *ptrchar)
{
	long position;
	int result = 0;
	position = find_file_pos(infile, genefile, 0);
	if(position >= 0){
		position += strlen(genefile);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	else{
		cerr <<"Readparam::read_genefile. Unable to find file name for gene file. Bailing out!"<<endl;
		exit(0);
	}
	return(result);
}

//**************************************

int Readparam::read_sindexfile(ifstream& infile, char *ptrchar)
{
	long position;
	int result = 0;
	position = find_file_pos(infile, sindexfile, 0);
	if(position >= 0){
		position += strlen(sindexfile);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	else{
		strcpy(ptrchar, "1");											// the s_index file doesn't exit. Assume all 1s.
	}
	return(result);
}


//**************************************

int Readparam::read_pathwayfile(ifstream& infile, char *ptrchar)
{
	long position;
	int result = 0;
	position = find_file_pos(infile, pathwayfile, 0);
	if(position >= 0){
		position += strlen(pathwayfile);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	else{
		cerr <<"Readparam::read_pathwayfile. Unable to find file name for pathway file. Bailing out!"<<endl;
		exit(0);
	}
	return(result);
}

//**************************************

int Readparam::read_outfilebymarker(ifstream& infile, char *ptrchar)
{
	long position;
	int result = 0;
	strcpy(ptrchar,"outfilebymarker.txt");
	position = find_file_pos(infile, outfilebymarker, 0);
	if(position >= 0){
		position += strlen(outfilebymarker);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	else{
//		cerr <<"Readparam::read_outfilebymarker. Unable to find file name for outfilebymarker."<<endl;
	}
	return(result);
}

//**************************************

void Readparam::read_plink(ifstream& infile, char *bed, char *bim, char *fam)
{
	long position;
	position = find_file_pos(infile, plinkfiles, 0);
	if(position >= 0){
		position += strlen(plinkfiles);
		infile.seekg(position, ios::beg);
		infile >> bed;
		infile >> bim;
		infile >> fam;
	}
	else{
		cerr <<"Readparam::read_freqfile. Unable to find file name for .freq file. Bailing out!"<<endl;
		exit(0);
	}
}

//**************************************

void Readparam::read_window(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, windows, 0);
	if(position >= 0){
		position += strlen(windows);
		infile.seekg(position, ios::beg);
		infile >> val;
	}
	else{
		val = 1;
	}
}

//**************************************

void Readparam::read_genopdt(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, genopdts, 0);
	if(position >= 0){
		position += strlen(genopdts);
		infile.seekg(position, ios::beg);
		infile >> val;
	}
	else{
		val = 0;
	}
}

//**************************************

void Readparam::read_inputformat(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, inputformat, 0);
	if(position >= 0){
		position += strlen(inputformat);
		infile.seekg(position, ios::beg);
		infile >> val;
	}
	else{
		val = 1;
	}
}

//**************************************

void Readparam::read_genebuffer(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, genebuffer, 0);
	if(position >= 0){
		position += strlen(genebuffer);
		infile.seekg(position, ios::beg);
		infile >> val;
	}
	else{
		val = 0;
	}
}

//**************************************

void Readparam::read_maxcpus(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, maxcpuss, 0);
	if(position >= 0){
		position += strlen(maxcpuss);
		infile.seekg(position, ios::beg);
		infile >> val;
	}
	else{
		val = 1;
	}
	/*
	if(val > 4){
		cerr <<"Readparam::read_maxcpus. maxcpus variable set to 4. It does not make much sense to use more than 4 CPUs for PDT."<<endl;
		val = 4;
	}*/
}

//**************************************

void Readparam::read_permute(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, permutation, 0);
	if(position >= 0){
		position += strlen(permutation);
		infile.seekg(position, ios::beg);
		infile >> val;
		if(val < 0){
			val = 0;
		}
	}
	else{
		val = 0;
	}
}

//**************************************

void Readparam::read_verbose(ifstream& infile, int& ver)
{
	long position;
	position = find_file_pos(infile, verbose, 0);
	if(position >= 0){
		position += strlen(verbose);
		infile.seekg(position, ios::beg);
		infile >> ver;
	}
	else{
		ver = 0;
	}
}

//**************************************

void Readparam::read_pdtave(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, pdt_stat, 0);
	if(position >= 0){
		position += strlen(pdt_stat);
		infile.seekg(position, ios::beg);
		infile >> val;
		if(val != 1){
			val = 0;
		}
	}
	else{
		val = 0;
	}
}

//**************************************

void Readparam::read_printnew(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, printnew, 0);
	if(position >= 0){
		position += strlen(printnew);
		infile.seekg(position, ios::beg);
		infile >> val;
		if(val != 1){
			val = 0;
		}
	}
	else{
		val = 0;
	}
}

//**************************************

void Readparam::read_options(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, optionss, 0);
	if(position >= 0){
		position += strlen(optionss);
		infile.seekg(position, ios::beg);
		infile >> val;
		if((val < 0) || (val > 4)){
			val = 0;
			cerr <<"Readparam::read_options. Unkown option. Set to default of 3.\n"<<endl;
		}
	}
	else{
		val = 3;
	}
}

//**************************************

void Readparam::read_maxfamsize(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, maxfamsize, 0);
	if(position >= 0){
		position += strlen(maxfamsize);
		infile.seekg(position, ios::beg);
		infile >> val;
	}
	else{
		cerr <<"Readparam::read_maxfamsize. max_fam_size is missing. Default set to 10. This can lead to a crash.\n"<<endl;
		val = 10;
	}
}

//**************************************

void Readparam::read_max_permutations(ifstream& infile, int& val)
{
	long position;
	position = find_file_pos(infile, maxpermutations, 0);
	if(position >= 0){
		position += strlen(maxpermutations);
		infile.seekg(position, ios::beg);
		infile >> val;
		if(val < 10){
			val = PER_LEN;
		}
	}
	else{
		cerr <<"Readparam::read_max_permutations. max_permutations is missing. Default set to 2000. This can lead to a crash.\n"<<endl;
		val = PER_LEN;
	}
}

//**************************************

int Readparam::read_specialmrklist(ifstream& infile, char *ptrchar)
{
	long position;
	int result = 0;
	position = find_file_pos(infile, specialmrklist, 0);
	if(position >= 0){
		position += strlen(specialmrklist);
		infile.seekg(position, ios::beg);
		infile >> ptrchar;
		result = 1;
	}
	return(result);
}

//**************************************




