#include "sort.h"

//**************************************************

Sort::Sort()
{
	Sort::list = NULL;
	Sort::size = 0;
	Sort::top = 0;
}

//**************************************************

Sort::~Sort()
{

}

//**************************************************

void Sort::init(int s, Record *l)
// s = total number of families
// k = key. i.e. the covariate we sort on. 0..(cov. - 1)
// l = pointer to the list to be sorted
{
	Sort::size = s;
	Sort::list = l;
	Sort::top = -1;                       // for stack control. right now stack is empty. 1st element is "0"	
}

//**************************************************

void Sort::split(int first, int last, int *splitpt)
{
	int i,j;
	int pivot = -1;
	int sm,lg,med;
	float median;											// holds value all others compare against
	/// start find pivot element. median of first, last & middle
	med = (first + last) / 2;
	if(list[first].cov < list[med].cov){
		sm = first;
		lg = med;
	}
	else{
		sm = med;
		lg = first;
	}
	if(list[last].cov <= list[sm].cov){
		pivot = sm;
	}
	else if(list[last].cov <= list[lg].cov){
		pivot = last;
	}
	else{
		pivot = lg;
	}
	swap(pivot, first);										// swap pivot element into first place
	median = list[first].cov;							// random array access are expensive, so we store it locally
	i = first + 1;
	j = last;
	while(i < j){
		while((list[j].cov >= median) && (j > (first + 1))){
			j--;
		}
		while((list[i].cov < median) && (i < last)){
			i++;
		}
		swap(i, j);											
	}
	swap(i, j);												// must undo last swap since we already had "i<j"
	if(median > list[j].cov){
		swap(first, j);										// "j" is the position of the last of the small elements, so we swap it with the pivot element which is at "first"
		*splitpt = j;
	}
	else if(median < list[j].cov){							// due to bad luck median was the smallest element
		*splitpt = first;
	}
	else{
		*splitpt = j;											// must know this to proceed further with this scheme
	}
}

//**************************************************

void Sort::qsort()
{
	int first = 0;											// first position in array
	int last = size - 1;									// you guessed it! The last position in the array/list
	int splitpt;											// where we break the subarray apart. note that array[splitpt] will be in its correct place
	push(first, last);
	while(top != -1){										// as long as there's stuff on the stack...
		pop(&first, &last);									// get first and last from stack
		for(;;){
			if((last-first) > SMALLSIZE){					// proceed with splitting sub-array
				split(first, last, &splitpt);
				if(first < (splitpt -1)){
					push(first, splitpt-1);
				}
				first = splitpt + 1;
			}
			else{											// sort the remainder via selection sort. Ineffiecient but less overhead. works well for small arrays
				selection_sort(first, last);
				break;										// sub-array sorted, get next from stack
			}
		}
	}
}

//**************************************************

void Sort::selection_sort(int first, int last)
{
    int i, j;
	int position;
	float small;
       
    for(i = first; i < last; i++){							// does nothing if first == last
		small = list[i].cov;
		position = i;
		for(j = i+1; j <= last; j++){
			if(small > list[j].cov){
				small = list[j].cov;
				position = j;
			}
		}
		if(position != i){
			swap(i, position);
		}
    }

}

//**************************************************

void Sort::swap(int i, int j)
{
	struct Record temp;
	temp.id = list[i].id;
	temp.cov = list[i].cov;
	temp.score1 = list[i].score1;
	temp.score2 = list[i].score2;
	list[i].id = list[j].id;
	list[i].cov = list[j].cov;
	list[i].score1 = list[j].score1;
	list[i].score2 = list[j].score2;
	list[j].id = temp.id;
	list[j].cov = temp.cov;
	list[j].score1 = temp.score1;
	list[j].score2 = temp.score2;
}

//**************************************************

void Sort::pop(int *a,int *b)                       // pop
{
    *a = st[top].a;								// need those puppies by refernce
    *b = st[top].b;
    top--;											// decrement top of stack
}


//**************************************************

void Sort::push(int a,int b)                        // push
{
    top++;											// increment top of stack BEFORE pushing stuff on there
    st[top].a = a;
    st[top].b = b;
}


//**************************************************
