#ifndef __SORT__
#define __SORT__

#include <stdio.h>
#include <stdlib.h>

struct Record{
	int id;                    // family id
	float cov;                  //  item to be sorted
	float score1;				//raw score
	float score2;				// another "score"
};

const int STACKSIZE = 10000;
const int SMALLSIZE = 20;

struct Stack{
	int a;						// lower border
	int b;						// upper border
};

class Sort{
public:
	Sort();
	~Sort();
	void init(int size, struct Record *list);			// size = number of covariates, key = covariate to be sorted, list = pointer to list of struct Record. This has to exist we will not allocate memory here.
	void swap(int i, int j);							// switch Record "i" with "j" in "list"
	void push(int i, int j);							// push start/stop on stack
	void pop(int *i, int *j);                           // get stuff of the stack
	void qsort();										// sorts everthing in list*
	void split(int first, int last, int *splitpt);
	void selection_sort(int first, int last);

	struct Stack st[STACKSIZE];

private:
	int top;
	int size;
	struct Record *list;
};

#endif
