#ifndef __SYNC_RANDOM_H__
#define __SYNC_RANDOM_H__

#ifdef WIN32
#include "pthread.h"
#include "sched.h"
#include "semaphore.h"
#include <windows.h>
#endif
#ifdef SOLARIS
#include <pthread.h>			// define _REENTRANT in makefile
#include <string.h>
#endif                          
#ifdef LINUX
#include <pthread.h>			// define _REENTRANT in makefile
#include <string.h>
#endif
#ifdef AIX
#include <pthread.h>			// define _REENTRANT in makefile
#include <string.h>
#endif

#include "max.h"

struct Sync_ran{
	int stop;									// if this is set to 1, thread should exit
	int ready;									// valid/ready entries 
	int empty;									// free entries...to be filled with random numbers
												// Note: maxranarrays - ready - empty = "cells" in use
	int list[maxranarrays];						// 0 = empty, 1 = ready, 2 = currently in use
	double ran_data[maxranarrays][maxran];		// where we store the data, see max.h [maxranarrays][maxran]
	pthread_mutex_t sync_random_mutex;			// 1 producer of random number, multiple consumers
	pthread_cond_t cond_waiting_producer;		// if random producer filled everthing up and is waiting on consumers to consume
	pthread_cond_t cond_waiting_consumer;		// if consumer is waiting on random producer to fill in some data

};

#endif
